# Formattable Class Reference

Formattable objects can be passed to the Format class or its subclasses for formatting. More...

`#include <fmtable.h>`

Inheritance diagram for Formattable:

## Public Types
enum | ISDATE { kIsDate }
| This enum is only used to let callers distinguish between the Formattable(UDate) constructor and the Formattable(double) constructor; the compiler cannot distinguish the signatures, since UDate is currently typedefed to be either double or long. More...
enum | Type { kDate, kDouble, kLong, kString, kArray, kInt64, kObject }
| Selector for flavor of data type contained within a Formattable object. More...
## Public Member Functions
| Formattable ()
| Default constructor.
| Formattable (UDate d, ISDATE flag)
| Creates a Formattable object with a UDate instance.
| Formattable (double d)
| Creates a Formattable object with a double number.
| Formattable (int32_t l)
| Creates a Formattable object with a long number.
| Formattable (int64_t ll)
| Creates a Formattable object with an int64_t number.
| Formattable (const char *strToCopy)
| Creates a Formattable object with a char string pointer.
| Formattable (const UnicodeString &strToCopy)
| Creates a Formattable object with a UnicodeString object to copy from.
| Formattable (UnicodeString *strToAdopt)
| Creates a Formattable object with a UnicodeString object to adopt from.
| Formattable (const Formattable *arrayToCopy, int32_t count)
| Creates a Formattable object with an array of Formattable objects.
| Formattable (UObject *objectToAdopt)
| Creates a Formattable object that adopts the given UObject.
| Formattable (const Formattable &)
| Copy constructor.
Formattable & | operator= (const Formattable &rhs)
| Assignment operator.
UBool | operator== (const Formattable &other) const
| Equality comparison.
UBool | operator!= (const Formattable &other) const
| Equality operator.
virtual | ~Formattable ()
| Destructor.
Formattable * | clone () const
| Clone this object.
Type | getType (void) const
| Gets the data type of this Formattable object.
UBool | isNumeric () const
| Returns TRUE if the data type of this Formattable object is kDouble, kLong, or kInt64.
double | getDouble (void) const
| Gets the double value of this object.
double | getDouble (UErrorCode &status) const
| Gets the double value of this object.
int32_t | getLong (void) const
| Gets the long value of this object.
int32_t | getLong (UErrorCode &status) const
| Gets the long value of this object.
int64_t | getInt64 (void) const
| Gets the int64 value of this object.
int64_t | getInt64 (UErrorCode &status) const
| Gets the int64 value of this object.
UDate | getDate () const
| Gets the Date value of this object.
UDate | getDate (UErrorCode &status) const
| Gets the Date value of this object.
UnicodeString & | getString (UnicodeString &result) const
| Gets the string value of this object.
UnicodeString & | getString (UnicodeString &result, UErrorCode &status) const
| Gets the string value of this object.
const UnicodeString & | getString (void) const
| Gets a const reference to the string value of this object.
const UnicodeString & | getString (UErrorCode &status) const
| Gets a const reference to the string value of this object.
UnicodeString & | getString (void)
| Gets a reference to the string value of this object.
UnicodeString & | getString (UErrorCode &status)
| Gets a reference to the string value of this object.
const Formattable * | getArray (int32_t &count) const
| Gets the array value and count of this object.
const Formattable * | getArray (int32_t &count, UErrorCode &status) const
| Gets the array value and count of this object.
Formattable & | operator[] (int32_t index)
| Accesses the specified element in the array value of this Formattable object.
const UObject * | getObject () const
| Returns a pointer to the UObject contained within this formattable, or NULL if this object does not contain a UObject.
void | setDouble (double d)
| Sets the double value of this object and changes the type to kDouble.
void | setLong (int32_t l)
| Sets the long value of this object and changes the type to kLong.
void | setInt64 (int64_t ll)
| Sets the int64 value of this object and changes the type to kInt64.
void | setDate (UDate d)
| Sets the Date value of this object and changes the type to kDate.
void | setString (const UnicodeString &stringToCopy)
| Sets the string value of this object and changes the type to kString.
void | setArray (const Formattable *array, int32_t count)
| Sets the array value and count of this object and changes the type to kArray.
void | adoptString (UnicodeString *stringToAdopt)
| Sets and adopts the string value and count of this object and changes the type to kArray.
void | adoptArray (Formattable *array, int32_t count)
| Sets and adopts the array value and count of this object and changes the type to kArray.
void | adoptObject (UObject *objectToAdopt)
| Sets and adopts the UObject value of this object and changes the type to kObject.
virtual UClassID | getDynamicClassID () const
| ICU "poor man's RTTI", returns a UClassID for the actual class.
int32_t | getLong (UErrorCode *status) const
| Deprecated variant of getLong(UErrorCode&).
## Static Public Member Functions
static UClassID | getStaticClassID ()
| ICU "poor man's RTTI", returns a UClassID for this class.

## Detailed Description

Formattable objects can be passed to the Format class or its subclasses for formatting.

Formattable is a thin wrapper class which interconverts between the primitive numeric types (double, long, etc.) as well as UDate and UnicodeString.

Internally, a Formattable object is a union of primitive types. As such, it can only store one flavor of data at a time. To determine what flavor of data it contains, use the getType method.

As of ICU 3.0, Formattable may also wrap a UObject pointer, which it owns. This allows an instance of any ICU class to be encapsulated in a Formattable. For legacy reasons and for efficiency, primitive numeric types are still stored directly within a Formattable.

The Formattable class is not suitable for subclassing.

Definition at line 47 of file fmtable.h.

## Member Enumeration Documentation

enum Formattable::ISDATE

This enum is only used to let callers distinguish between the Formattable(UDate) constructor and the Formattable(double) constructor; the compiler cannot distinguish the signatures, since UDate is currently typedefed to be either double or long.

If UDate is changed later to be a bonafide class or struct, then we no longer need this enum.

Stable:
  ICU 2.4

Definition at line 58 of file fmtable.h.

enum Formattable::Type

Selector for flavor of data type contained within a Formattable object.

Formattable is a union of several different types, and at any time contains exactly one type.

Stable:
  ICU 2.4

Enumerator:

  kDate | Selector indicating a UDate value. Use getDate to retrieve the value. Stable: ICU 2.4
  kDouble | Selector indicating a double value. Use getDouble to retrieve the value. Stable: ICU 2.4
  kLong | Selector indicating a 32-bit integer value. Use getLong to retrieve the value. Stable: ICU 2.4
  kString | Selector indicating a UnicodeString value. Use getString to retrieve the value. Stable: ICU 2.4
  kArray | Selector indicating an array of Formattables. Use getArray to retrieve the value. Stable: ICU 2.4
  kInt64 | Selector indicating a 64-bit integer value. Use getInt64 to retrieve the value. Stable: ICU 2.8
  kObject | Selector indicating a UObject value. Use getObject to retrieve the value. Stable: ICU 3.0

Definition at line 189 of file fmtable.h.

## Constructor & Destructor Documentation

Formattable::Formattable | ( |  | ) |

Default constructor.

Stable:
  ICU 2.4

Formattable::Formattable | ( | UDate | d,
|  | ISDATE | flag |
| ) |  |  |

Creates a Formattable object with a UDate instance.

Parameters:

  | d | the UDate instance.
  | flag | the flag to indicate this is a date. Always set it to kIsDate

Stable:
  ICU 2.0

Formattable::Formattable | ( | double | d | ) |

Creates a Formattable object with a double number.

Parameters:

  | d | the double number.

Stable:
  ICU 2.0

Formattable::Formattable | ( | int32_t | l | ) |

Creates a Formattable object with a long number.

Parameters:

  | l | the long number.

Stable:
  ICU 2.0

Formattable::Formattable | ( | int64_t | ll | ) |

Creates a Formattable object with an int64_t number.

Parameters:

  | ll | the int64_t number.

Stable:
  ICU 2.8

Formattable::Formattable | ( | const char * | strToCopy | ) |

Creates a Formattable object with a char string pointer.

Assumes that the char string is null terminated.

Parameters:

  | strToCopy | the char string.

Stable:
  ICU 2.0

Formattable::Formattable | ( | const UnicodeString & | strToCopy | ) |

Creates a Formattable object with a UnicodeString object to copy from.

Parameters:

  | strToCopy | the UnicodeString string.

Stable:
  ICU 2.0

Formattable::Formattable | ( | UnicodeString * | strToAdopt | ) |

Creates a Formattable object with a UnicodeString object to adopt from.

Parameters:

  | strToAdopt | the UnicodeString string.

Stable:
  ICU 2.0

Formattable::Formattable | ( | const Formattable * | arrayToCopy,
|  | int32_t | count |
| ) |  |  |

Creates a Formattable object with an array of Formattable objects.

Parameters:

  | arrayToCopy | the Formattable object array.
  | count | the array count.

Stable:
  ICU 2.0

Formattable::Formattable | ( | UObject * | objectToAdopt | ) |

Creates a Formattable object that adopts the given UObject.

Parameters:

  | objectToAdopt | the UObject to set this object to

Stable:
  ICU 3.0

Formattable::Formattable | ( | const Formattable & |  | ) |

Copy constructor.

Stable:
  ICU 2.0

virtual Formattable::~Formattable | ( |  | ) | `[virtual]`

Destructor.

Stable:
  ICU 2.0

## Member Function Documentation

void Formattable::adoptArray | ( | Formattable * | array,
|  | int32_t | count |
| ) |  |  |

Sets and adopts the array value and count of this object and changes the type to kArray.

Stable:
  ICU 2.0

void Formattable::adoptObject | ( | UObject * | objectToAdopt | ) |

Sets and adopts the UObject value of this object and changes the type to kObject.

After this call, the caller must not delete the given object.

Parameters:

  | objectToAdopt | the UObject value to be adopted

Stable:
  ICU 3.0

void Formattable::adoptString | ( | UnicodeString * | stringToAdopt | ) |

Sets and adopts the string value and count of this object and changes the type to kArray.

Parameters:

  | stringToAdopt | the new string value to be adopted.

Stable:
  ICU 2.0

Formattable* Formattable::clone | ( |  | ) | const

Clone this object.

Clones can be used concurrently in multiple threads. If an error occurs, then NULL is returned. The caller must delete the clone.

Returns:
  a clone of this object

See also:
  getDynamicClassID

Stable:
  ICU 2.8

const Formattable* Formattable::getArray | ( | int32_t & | count,
|  | UErrorCode & | status |
| ) |  |  | const

Gets the array value and count of this object.

If the type is not an array, status is set to U_INVALID_FORMAT_ERROR, count is set to 0, and the result is NULL.

Parameters:

  | count | fill-in with the count of this object.
  | status | the error code.

Returns:
  the array value of this object.

Stable:
  ICU 3.0

const Formattable* Formattable::getArray | ( | int32_t & | count | ) | const`[inline]`

Gets the array value and count of this object.

If this object is not of type kArray then the result is undefined.

Parameters:

  | count | fill-in with the count of this object.

Returns:
  the array value of this object.

Stable:
  ICU 2.0

Definition at line 411 of file fmtable.h.

UDate Formattable::getDate | ( | UErrorCode & | status | ) | const`[inline]`

Gets the Date value of this object.

If the type is not a date, status is set to U_INVALID_FORMAT_ERROR and the return value is undefined.

Parameters:

  | status | the error code.

Returns:
  the Date value of this object.

Stable:
  ICU 3.0

Definition at line 563 of file fmtable.h.

References kDate, U_INVALID_FORMAT_ERROR, and U_SUCCESS.

UDate Formattable::getDate | ( |  | ) | const`[inline]`

Gets the Date value of this object.

If this object is not of type kDate then the result is undefined.

Returns:
  the Date value of this object.

Stable:
  ICU 2.0

Definition at line 334 of file fmtable.h.

double Formattable::getDouble | ( | UErrorCode & | status | ) | const

Gets the double value of this object.

If this object is of type long or int64 then a casting conversion is peformed, with possible loss of precision. If the type is kObject and the object is a Measure, then the result of getNumber().getDouble(status) is returned. If this object is neither a numeric type nor a Measure, then 0 is returned and the status is set to U_INVALID_FORMAT_ERROR.

Parameters:

  | status | the error code

Returns:
  the double value of this object.

Stable:
  ICU 3.0

double Formattable::getDouble | ( | void |  | ) | const`[inline]`

Gets the double value of this object.

If this object is not of type kDouble then the result is undefined.

Returns:
  the double value of this object.

Stable:
  ICU 2.0

Definition at line 261 of file fmtable.h.

virtual UClassID Formattable::getDynamicClassID | ( |  | ) | const`[virtual]`

ICU "poor man's RTTI", returns a UClassID for the actual class.

Stable:
  ICU 2.2

Implements UObject.

int64_t Formattable::getInt64 | ( | UErrorCode & | status | ) | const

Gets the int64 value of this object.

If this object is of type kDouble and the magnitude is too large to fit in an int64, then the maximum or minimum int64 value, as appropriate, is returned and the status is set to U_INVALID_FORMAT_ERROR. If the magnitude fits in an int64, then a casting conversion is peformed, with truncation of any fractional part. If the type is kObject and the object is a Measure, then the result of getNumber().getDouble(status) is returned. If this object is neither a numeric type nor a Measure, then 0 is returned and the status is set to U_INVALID_FORMAT_ERROR.

Parameters:

  | status | the error code

Returns:
  the int64 value of this object.

Stable:
  ICU 3.0

int64_t Formattable::getInt64 | ( | void |  | ) | const`[inline]`

Gets the int64 value of this object.

If this object is not of type kInt64 then the result is undefined.

Returns:
  the int64 value of this object.

Stable:
  ICU 2.8

Definition at line 309 of file fmtable.h.

int32_t Formattable::getLong | ( | UErrorCode * | status | ) | const`[inline]`

Deprecated variant of getLong(UErrorCode&).

Parameters:

  | status | the error code

Returns:
  the long value of this object.

Deprecated:
  ICU 3.0 use getLong(UErrorCode&) instead

Definition at line 581 of file fmtable.h.

References getLong().

int32_t Formattable::getLong | ( | UErrorCode & | status | ) | const

Gets the long value of this object.

If the magnitude is too large to fit in a long, then the maximum or minimum long value, as appropriate, is returned and the status is set to U_INVALID_FORMAT_ERROR. If this object is of type kInt64 and it fits within a long, then no precision is lost. If it is of type kDouble, then a casting conversion is peformed, with truncation of any fractional part. If the type is kObject and the object is a Measure, then the result of getNumber().getLong(status) is returned. If this object is neither a numeric type nor a Measure, then 0 is returned and the status is set to U_INVALID_FORMAT_ERROR.

Parameters:

  | status | the error code

Returns:
  the long value of this object.

Stable:
  ICU 3.0

int32_t Formattable::getLong | ( | void |  | ) | const`[inline]`

Gets the long value of this object.

If this object is not of type kLong then the result is undefined.

Returns:
  the long value of this object.

Stable:
  ICU 2.0

Definition at line 283 of file fmtable.h.

Referenced by getLong().

const UObject* Formattable::getObject | ( |  | ) | const

Returns a pointer to the UObject contained within this formattable, or NULL if this object does not contain a UObject.

Returns:
  a UObject pointer, or NULL

Stable:
  ICU 3.0

static UClassID Formattable::getStaticClassID | ( |  | ) | `[static]`

ICU "poor man's RTTI", returns a UClassID for this class.

Stable:
  ICU 2.2

UnicodeString& Formattable::getString | ( | UErrorCode & | status | ) |

Gets a reference to the string value of this object.

If the type is not a string, status is set to U_INVALID_FORMAT_ERROR and the result is a bogus string.

Parameters:

  | status | the error code.

Returns:
  a reference to the string value of this object.

Stable:
  ICU 3.0

UnicodeString & Formattable::getString | ( | void |  | ) | `[inline]`

Gets a reference to the string value of this object.

If this object is not of type kString then the result is undefined.

Returns:
  a reference to the string value of this object.

Stable:
  ICU 2.0

Definition at line 577 of file fmtable.h.

const UnicodeString& Formattable::getString | ( | UErrorCode & | status | ) | const

Gets a const reference to the string value of this object.

If the type is not a string, status is set to U_INVALID_FORMAT_ERROR and the result is a bogus string.

Parameters:

  | status | the error code.

Returns:
  a const reference to the string value of this object.

Stable:
  ICU 3.0

const UnicodeString & Formattable::getString | ( | void |  | ) | const`[inline]`

Gets a const reference to the string value of this object.

If this object is not of type kString then the result is undefined.

Returns:
  a const reference to the string value of this object.

Stable:
  ICU 2.0

Definition at line 573 of file fmtable.h.

UnicodeString& Formattable::getString | ( | UnicodeString & | result,
|  | UErrorCode & | status |
| ) |  |  | const

Gets the string value of this object.

If the type is not a string, status is set to U_INVALID_FORMAT_ERROR and a bogus string is returned.

Parameters:

  | result | Output param to receive the Date value of this object.
  | status | the error code.

Returns:
  A reference to 'result'.

Stable:
  ICU 3.0

UnicodeString& Formattable::getString | ( | UnicodeString & | result | ) | const`[inline]`

Gets the string value of this object.

If this object is not of type kString then the result is undefined.

Parameters:

  | result | Output param to receive the Date value of this object.

Returns:
  A reference to 'result'.

Stable:
  ICU 2.0

Definition at line 353 of file fmtable.h.

Type Formattable::getType | ( | void |  | ) | const

Gets the data type of this Formattable object.

Returns:
  the data type of this Formattable object.

Stable:
  ICU 2.0

UBool Formattable::isNumeric | ( |  | ) | const

Returns TRUE if the data type of this Formattable object is kDouble, kLong, or kInt64.

Returns:
  TRUE if this is a pure numeric object

Stable:
  ICU 3.0

UBool Formattable::operator!= | ( | const Formattable & | other | ) | const`[inline]`

Equality operator.

Parameters:

  | other | the object to be compared with.

Returns:
  TRUE if other are unequal to this, FALSE otherwise.

Stable:
  ICU 2.0

Definition at line 161 of file fmtable.h.

Formattable& Formattable::operator= | ( | const Formattable & | rhs | ) |

Assignment operator.

Parameters:

  | rhs | The Formattable object to copy into this object.

Stable:
  ICU 2.0

UBool Formattable::operator== | ( | const Formattable & | other | ) | const

Equality comparison.

Parameters:

  | other | the object to be compared with.

Returns:
  TRUE if other are equal to this, FALSE otherwise.

Stable:
  ICU 2.0

Formattable& Formattable::operator[] | ( | int32_t | index | ) | `[inline]`

Accesses the specified element in the array value of this Formattable object.

If this object is not of type kArray then the result is undefined.

Parameters:

  | index | the specified index.

Returns:
  the accessed element in the array.

Stable:
  ICU 2.0

Definition at line 433 of file fmtable.h.

References fArrayAndCount.

void Formattable::setArray | ( | const Formattable * | array,
|  | int32_t | count |
| ) |  |  |

Sets the array value and count of this object and changes the type to kArray.

Parameters:

  | array | the array value.
  | count | the number of array elements to be copied.

Stable:
  ICU 2.0

void Formattable::setDate | ( | UDate | d | ) |

Sets the Date value of this object and changes the type to kDate.

Parameters:

  | d | the new Date value to be set.

Stable:
  ICU 2.0

void Formattable::setDouble | ( | double | d | ) |

Sets the double value of this object and changes the type to kDouble.

Parameters:

  | d | the new double value to be set.

Stable:
  ICU 2.0

void Formattable::setInt64 | ( | int64_t | ll | ) |

Sets the int64 value of this object and changes the type to kInt64.

Parameters:

  | ll | the new int64 value to be set.

Stable:
  ICU 2.8

void Formattable::setLong | ( | int32_t | l | ) |

Sets the long value of this object and changes the type to kLong.

Parameters:

  | l | the new long value to be set.

Stable:
  ICU 2.0

void Formattable::setString | ( | const UnicodeString & | stringToCopy | ) |

Sets the string value of this object and changes the type to kString.

Parameters:

  | stringToCopy | the new string value to be set.

Stable:
  ICU 2.0

The documentation for this class was generated from the following file:

- fmtable.h